(document:surround "/std/frame")
(document:envelop with-translation _ "alterator-install2")

(define (progress-monitor msg)
	;;(package "name" step 2)
	;;(done #t)
	;;(init #t)
	;;(stage FOOBAR max 5)
	;;(error CODE filesystems "FS")

	(case (cond-car msg)
		((error)
			(remove-mailbox progress-monitor)
			(woo-catch/message (thunk (woo-try "unmount" "/basesystem")))

			(case (cond-plistq 'error msg "")
			  ((DISKSPACE)
				(document:replace "/install2/basesystem-error"
						  'message (format #f (_ "Insufficient disk space on the ~A filesystem")
								   (cond-plistq 'filesystems msg ""))
						  'hint (_ "Hint: You can press 'Previous' and correct the problem.")))
			  ((DISKNODES)
				(document:replace "/install2/basesystem-error"
						  'message (format #f (_ "Insufficient inodes on the ~A filesystem")
								   (cond-plistq 'filesystems msg ""))
						  'hint (_ "Hint: You can press 'Previous' and correct the problem."))))
		)
		((init)
			(progress text (_ "Prepare for installation ...")))

		((done)
			(remove-mailbox progress-monitor)
			(woo-catch/message (thunk (woo-write "/deadline")))
			(woo-write "/autoinstall/deadline")
			(frame:next))

		((package)
			(status-l text (cond-plistq 'package msg (_ "Unknown")))
			(progress value (cond-plistq 'step msg 0)))

		((stage)
			(case (cond-plistq 'stage msg "")
				((download-pkgs) (progress text (_ "Acquiring packages ...")))
				((install-pkgs)  (progress text (_ "Installing packages ..."))))
			(progress maximum (cond-plistq 'max msg 0)))
	)
)

(vbox max-height 150
	(spacer)
	(document:id progress (progressbar maximum 0 value 0 text " "))
	(document:id status-l (label ""))
	(spacer))

(add-mailbox progress-monitor)

(document:root (when loaded
                 (frame:next-activity #f)
                 (frame:back-activity #f)
		 (woo-write "/basesystem")
		 (woo-write "/autoinstall/basesystem")))
